#ifndef AI_H_
#define AI_H_

#include <stdexcept>
#include "SDL.h"
#include "actioneventqueue.h"
#include "common.h"
#include "playerpool.h"
//#include "timers.h"

#define DIFFICUTY_EASY		1
#define DIFFICUTY_MEDIUM	2
#define DIFFICUTY_HARD		3
#define DIFFICUTY_VERYHARD	4

#define GAME_MODE_SINGLE_PLAYER	0
#define GAME_MODE_SKIRMISH	    1
#define GAME_MODE_MULTI_PLAYER  2


#define AI_MISSION_NONE			1	// No mission
#define AI_MISSION_GUARD		2	// Guard a area
#define AI_MISSION_ATTACK_BASE	3	// Attack the base of the human user



class ai{
	public:
		ai();
		~ai();
		void SetDifficulty (int Diff);
		void DefendUnits (Player *Player, int PlayerNumb);
		void DefendComputerPlayerBaseUnderAttack (Player *Player, int PlayerNumb, UnitOrStructure *Enimy, Structure *StructureUnderAttack);
		void DefendComputerPlayerUnitUnderAttack (Player *Player, int PlayerNumb, UnitOrStructure *Enimy, Unit *UnitUnderAttack);
		void handle ();

	private:
		int 		NumbPlayers;
		int			HumanPlayerNumb;
		int			Difficulty;
		Uint32		LastBuildTickCount, LastAttackTickCount;
		Uint32		LplayerBasePos;
		Uint16		UnitBuildMultiplexer;

//		Uint16	getDist(Uint16 pos1, Uint16 pos2);
		Uint32		getDist(Uint32 pos1, Uint32 pos2);
		bool		CanBuildAt (Uint8 PlayerNumb, const char *structname, Uint32 pos);
		bool		BuildStructure (Player *Player, int PlayerNumb, const char *structname, Uint32 ConstYardPos);
		unsigned int	FindClosesedTiberium (Unit *Unit);
		void		DefendStructures (Player *Player, int PlayerNumb);
		void		Build (Player *Player, int PlayerNumb);
		Unit*		EnemyUnitInRange (int MyPlayerNumb, Unit* MyUnit, int AttackRange = -1 );
		Unit*		EnemyUnitInRange (int MyPlayerNumb, Structure* MyStructure, int AttackRange = -1 );
		Structure*	EnemyStructureInRange (int MyPlayerNumb, Unit* MyUnit, int AttackRange = -1 );

		void		patrolAndAttack (Player *Player, int PlayerNumb);

};
#endif //AI_H_
