#include <cctype>
//#include <string>

#include "logger.h"
#include "mapsini.h"
#include "vfs.h"
//
//

using std::string;


//##################################################################################
//
//
//	Multiplayer maps!!
//
//
//##################################################################################



MissionMapsClass::MissionMapsClass()
{
	ReadMissionData ();
}

MissionMapsClass::~MissionMapsClass()
{


}

void MissionMapsClass::GetGdiMissionMap (unsigned int MissionNr, string &Name)
{
	if (GdiMissionMaps.size() > MissionNr)
		Name = GdiMissionMaps[MissionNr];

}
void MissionMapsClass::GetNodMissionMap (unsigned int MissionNr, string &Name)
{
	if (NodMissionMaps.size() > MissionNr)
		Name = NodMissionMaps[MissionNr];
}

void MissionMapsClass::ReadMissionData (void)
{
VFile		*MapFile;
char		Line[255];
std::string	tmpString;
Uint32		pos;

	// I am not sure how the maps from td work so...
 	if (getConfig().gamenum != GAME_RA) 
		return;

	/* get the offset and size of the binfile along with a pointer to it */
	//binfile = mixes->getOffsetAndSize(binname, &offset, &size);
	MapFile = VFS_Open("mission.ini");

	if(MapFile == NULL) {
		logger->error("Unable to locate mission.ini file!\n");
		return;
	}

	printf ("Succes at opening mission.ini\n");

	
	
	while (MapFile->getLine(Line, sizeof (Line))){
//		tmpString.empty();
		tmpString = Line;		
//		memset (Line, '\0', sizeof (Line));
		int i = 0;
		while (tmpString[i] != '\0'){
			//trying to remove this line to remove the error (can play anyway
			if (tmpString[i] == '[' || tmpString[i] == ']'){
				tmpString.erase(i,i+1);
			}
			i++;
		}
//trying to remove this line to remove the error (can play anyway)
		// For now we don't support the mission objective strings
		if ((pos = tmpString.find (".INI",0)) != string::npos){
			tmpString.erase (pos, pos+4);
			if ((pos = tmpString.find ("SCU",0)) != string::npos){
				NodMissionMaps.push_back (tmpString);
				//printf ("NOD ini found: %s\n", tmpString.c_str());
			}else{
				GdiMissionMaps.push_back (tmpString);
				//printf ("GDI ini found: %s\n", tmpString.c_str());
			}

		}else{
		}
		//	Mapdata.push_back (tmpString);	
		//printf ("Line read = %s\n", tmpString.c_str());
	}
}

//##################################################################################
//
//
//	Multiplayer maps!!
//
//
//##################################################################################

MPmapsClass::MPmapsClass()
{
	this->ReadMapData ();
}

MPmapsClass::~MPmapsClass()
{


}

bool MPmapsClass::GetMapDescription (unsigned int Index, string &String)
{
	if ( Index < MapDescriptions.size() ){
		String = MapDescriptions[Index];
		return true;
	}
	return false;
}

bool MPmapsClass::GetMapName (unsigned int Index, string &Name)
{
	if ( Index < MapNames.size() ){
		Name = MapNames[Index];
		return true;
	}
	return false;
}


void MPmapsClass::ReadMapData (void)
{
VFile		*MapFile;
char		Line[255];
std::string	tmpString;
Uint32		pos, pos1;

	// I am not sure how the maps from td work so...
 	if (getConfig().gamenum != GAME_RA) 
		return;

	MapFile = VFS_Open("missions.pkt");

	if(MapFile == NULL) {
		logger->error("Unable to locate mission.ini file!\n");
		return;
	}

	while (MapFile->getLine(Line, sizeof (Line))){

		tmpString = Line; 

		int i = 0;
		while (tmpString[i] != '\0'){
			if (tmpString[i] == '[' || tmpString[i] == ']'){
				tmpString.erase(i,i+1);
			}
			i++;
		}

		if ((pos = tmpString.find (".INI",0)) != string::npos){
			//tmpString.erase (pos, pos+3);
			if (pos < tmpString.size())
				MapNames.push_back (tmpString.substr (0, pos));
			//printf ("MP mpa found: %s\n", tmpString.substr (0, pos).c_str());
		}

		if ((pos = tmpString.find ("=",0)) != string::npos){
			if ((pos1 = tmpString.find (")",0)) != string::npos){
				//tmpString.erase (pos, pos+3);
				if (pos < tmpString.size())
					MapDescriptions.push_back (tmpString.substr (pos+1, tmpString.size()-(pos+1)-2));
				//printf ("MP map name: %s\n", tmpString.substr (pos+1, tmpString.size()-(pos+1)-2).c_str());
			}
		}
		//Mapdata.push_back (tmpString);

	}
}
