#include "common.h"
#include "config.h"
#include "cpsimage.h"
#include "graphicsengine.h"
#include "widgets.h"
#include "font.h"
#include "imagecache.h"
#include "sdllayer.h"

using std::string;

//#define USE_IMAGE_POOL

//#define	FONT	"scorefnt.fnt"		/* oke */
//#define	FONT	"12metfnt.fnt"
#define	FONT	"type.fnt"
//#define	FONT	"editfnt.fnt"
//#define	FONT	"3point.fnt"
//#define	FONT	"8point.fnt"
//#define	FONT	"led.fnt"
//#define	FONT	"vcr.fnt"
//#define	FONT	"12metfnt.fnt"
//#define	FONT	"6point.fnt"
//#define	FONT	"grad6fnt.fnt"
//#define	FONT	"help.fnt"


// Constructor
ButtonClass::ButtonClass():ButtonFont(FONT)
{

	this->ButtonImg_up	= NULL;
	this->ButtonImg_down	= NULL;
	this->ButtonImg_over	= NULL;
	this->ButtonState	= BUTTON_STATE_UP;
	this->WindowToDrawOn	= NULL;
	this->ButtonType	= BUTTON_TYPE_DEFAULT;
//	this->ButtonType = BUTTON_TYPE_LOCK_UNLOCK;

	display = pc::gfxeng->get_SDL_ScreenSurface();

	// The default button color is white ;)
	if (display != NULL)
		color	= SDL_MapRGB(display->format, 0xff, 0xff, 0xff);

	// Initialize position and size to something
	SizeAndPosition.x = 0;
	SizeAndPosition.y = 0;
	SizeAndPosition.w = 100;
	SizeAndPosition.h = 100;

	this->setcolor (96, 0, 0);
	this->setFontColor_up (220, 0, 0);
	this->setFontColor_down (0xff, 0xff, 0xff);


}

// Destructor
ButtonClass::~ButtonClass()
{
	if (this->ButtonImg_up != NULL)
		SDL_FreeSurface(ButtonImg_up);

	if (this->ButtonImg_down != NULL)
		SDL_FreeSurface(ButtonImg_down);

	if (this->ButtonImg_over != NULL)
		SDL_FreeSurface(this->ButtonImg_over);
}

// Set the surface (window) to draw the button on
void ButtonClass::SetDrawingSurface(SDL_Surface *Surface)
{
	if (Surface != NULL)
		display = Surface;

}

// Set the surface (window) to draw the button on
void ButtonClass::SetDrawingWindow(RA_WindowClass *Window)
{
	if (Window != NULL){
		WindowToDrawOn = Window;
		display = WindowToDrawOn->GetWindowSurface ();
	}

}

void ButtonClass::setButtonState (int state)
{
	this->ButtonState = state;
}

int ButtonClass::getButtonState (void)
{
	return this->ButtonState;
}

bool ButtonClass::handleMouseEvent (SDL_Event event)
{
bool OldButtonState;

	if (this->ButtonType == BUTTON_TYPE_EXTERNAL)
		return false;

	OldButtonState = this->ButtonState;

	// Change the button state ;)
	if (event.type == SDL_MOUSEBUTTONDOWN){
		if (this->mouseover()){
			if (this->ButtonState != BUTTON_STATE_DOWN || ButtonType == BUTTON_TYPE_DEFAULT)
				this->ButtonState = BUTTON_STATE_DOWN;
			else
				this->ButtonState = BUTTON_STATE_UP;
		}
	}else if(event.type == SDL_MOUSEBUTTONUP || !this->mouseover() && this->ButtonState != BUTTON_STATE_UP){
		if (this->ButtonType == BUTTON_TYPE_DEFAULT || this->ButtonState == BUTTON_STATE_OVER){
			this->ButtonState = BUTTON_STATE_UP;
		}
	}else if (mouseover() && this->ButtonState != BUTTON_STATE_DOWN){
		this->ButtonState = BUTTON_STATE_OVER;
	}//else if (this->ButtonState == BUTTON_STATE_OVER)
	//	this->ButtonState = BUTTON_STATE_UP;

	if (OldButtonState != this->ButtonState){
		//this->drawbutton ();
		return true;
	}

	return false;
}


void ButtonClass::setFontColor_up (Uint8 red, Uint8 green, Uint8 blue)
{
	this->FontColor_up.r = red;
	this->FontColor_up.g = green;
	this->FontColor_up.b = blue;
}

void ButtonClass::setFontColor_down (Uint8 red, Uint8 green, Uint8 blue)
{
	this->FontColor_down.r = red;
	this->FontColor_down.g = green;
	this->FontColor_down.b = blue;
}
void ButtonClass::setcolor (Uint8 red, Uint8 green, Uint8 blue)
{
	ButtonColor.r = red;
	ButtonColor.g = green;
	ButtonColor.b = blue;
	color = SDL_MapRGB(display->format, red, green, blue);
	LightColor = SDL_MapRGB(display->format, (char) (red*1.3), (char) (green*1.3), (char) (blue*1.3));
	DarkColor = SDL_MapRGB(display->format, (char) (red*0.7), (char) (green*0.7), (char) (blue*0.7));
}

void ButtonClass::setcolor (Uint32 SDL_color)
{
//SDL_Color TempCol;

//	SDL_GetRGB( SDL_color, display->format, &TempCol.r, &TempCol.g, &TempCol.b );
//	this->setcolor (TempCol.r, TempCol.g, TempCol.b);
	color = SDL_color;
}

void ButtonClass::setcolor (SDL_Color Color)
{
/*
	color = SDL_MapRGB(display->format, Color.r, Color.g, Color.b);
	LightColor = SDL_MapRGB(display->format, (char) (Color.r*1.3), (char) (Color.g*1.3), (char) (Color.b*1.3));
	DarkColor = SDL_MapRGB(display->format, (char) (Color.r*0.7), (char) (Color.g*0.7), (char) (Color.b*0.7));
*/
	this->setcolor (Color.r, Color.g, Color.b);
//	printf ("%s line %i: Set button rgb color: %i, %i, %i\n", __FILE__, __LINE__, Color.r, Color.g, Color.b);
}


void ButtonClass::settext (const std::string& text)
{
	ButtonText = text;
}

void ButtonClass::setposition (int x, int y)
{
	SizeAndPosition.x = x;
	SizeAndPosition.y = y;
}

void ButtonClass::setsize (int w, int h)
{
	SizeAndPosition.w	= w;
	SizeAndPosition.h	= h;
}

/* Function return true if the mouse is on top of the button */
bool ButtonClass::mouseover(void)
{
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}

	if (mx > SizeAndPosition.x && mx < SizeAndPosition.x + SizeAndPosition.w)
		if (my > SizeAndPosition.y && my < SizeAndPosition.y + SizeAndPosition.h)
			return true;
	return false;
}

void ButtonClass::CreateSurface(const std::string& ButtonText, int Xpos, int Ypos, int Width, int Heigth )
{
	this->settext (ButtonText);
	this->setposition (Xpos, Ypos);
	this->setsize (Width, Heigth);
	this->CreateSurface();
}


void ButtonClass::CreateSurface( void )
{
SDL_Rect	dest;

	// this is the destination as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = SizeAndPosition.w;
	dest.h = SizeAndPosition.h;

	// Free the button image surface (if needed)
	if (this->ButtonImg_up != NULL)
		SDL_FreeSurface(ButtonImg_up);

	ButtonImg_up = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);

	// Fill the surface with the correct color
	SDL_FillRect(ButtonImg_up, &dest, color);

	// draw left and right lines
	dest.w = 2;
	dest.h = SizeAndPosition.h;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_up, &dest, LightColor);
	dest.x = SizeAndPosition.w - 2;
	SDL_FillRect(ButtonImg_up, &dest, DarkColor);


	// draw top and bottum lines
	dest.w = SizeAndPosition.w;
	dest.h = 2;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_up, &dest, LightColor);
	dest.y = SizeAndPosition.h - 2;
	SDL_FillRect(ButtonImg_up, &dest, DarkColor);

	//
	SDL_SetColorKey(this->ButtonImg_up, SDL_SRCCOLORKEY, 0);

	int TextWidth = this->ButtonFont.calcTextWidth(ButtonText);
	int TextHeith = this->ButtonFont.getHeight();

	//ButtonFont.SetColor (this->FontColor_up.r, this->FontColor_up.g, this->FontColor_up.b);
//	ButtonFont.SetColor (150, 0, 0);


	// Draw the button text on the button
#if 0
	ButtonFont.SetColors (FontColor_up, ButtonColor);
	ButtonFont.drawText(this->ButtonText, ButtonImg_up, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#else
	ButtonFont.drawText(this->ButtonText, ButtonImg_up, FontColor_up, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#endif

//###############################################################
//
//	FROM HERE WE MAKE THE BUTTON DOWN IMAGE
//
//###############################################################

	// this is the destination as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = SizeAndPosition.w;
	dest.h = SizeAndPosition.h;

	// Free the button image surface (if needed)
	if (this->ButtonImg_down != NULL)
		SDL_FreeSurface(ButtonImg_down);

	ButtonImg_down = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);

	// Fill the surface with the correct color
	SDL_FillRect(ButtonImg_down, &dest, color);

	// draw left and right lines
	dest.w = 2;
	dest.h = SizeAndPosition.h;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_down, &dest, DarkColor);
	dest.x = SizeAndPosition.w - 2;
	SDL_FillRect(ButtonImg_down, &dest, LightColor);


	// draw top and bottum lines
	dest.w = SizeAndPosition.w;
	dest.h = 2;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_down, &dest, DarkColor);
	dest.y = SizeAndPosition.h - 2;
	SDL_FillRect(ButtonImg_down, &dest, LightColor);

	//
	SDL_SetColorKey(this->ButtonImg_down, SDL_SRCCOLORKEY, 0);

	TextWidth = this->ButtonFont.calcTextWidth(ButtonText);
	TextHeith = this->ButtonFont.getHeight();

	//ButtonFont.SetColor (this->FontColor_down.r, this->FontColor_down.g, this->FontColor_down.b);

//	ButtonFont.SetColor (150, 0, 0);

	// Draw the button text on the button
#if 0
	ButtonFont.SetColors (FontColor_down, ButtonColor);
	ButtonFont.drawText(this->ButtonText, ButtonImg_down, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#else
	ButtonFont.drawText(this->ButtonText, ButtonImg_down, FontColor_down, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#endif

//###############################################################
//
//	FROM HERE WE MAKE THE BUTTON OVER IMAGE (BUTTON UP WITH FONTCOLOR FOR BUTTON DOWN)
//
//###############################################################

	// this is the destination as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = SizeAndPosition.w;
	dest.h = SizeAndPosition.h;

	// Free the button image surface (if needed)
	if (this->ButtonImg_over != NULL)
		SDL_FreeSurface(this->ButtonImg_over);

	ButtonImg_over = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);

	// Fill the surface with the correct color
	SDL_FillRect(ButtonImg_over, &dest, color);

	// draw left and right lines
	dest.w = 2;
	dest.h = SizeAndPosition.h;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_over, &dest, LightColor);
	dest.x = SizeAndPosition.w - 2;
	SDL_FillRect(ButtonImg_over, &dest, DarkColor);


	// draw top and bottum lines
	dest.w = SizeAndPosition.w;
	dest.h = 2;
	dest.x = 0;
	dest.y = 0;
	SDL_FillRect(ButtonImg_over, &dest, LightColor);
	dest.y = SizeAndPosition.h - 2;
	SDL_FillRect(ButtonImg_over, &dest, DarkColor);

	//
	SDL_SetColorKey(this->ButtonImg_over, SDL_SRCCOLORKEY, 0);

	TextWidth = this->ButtonFont.calcTextWidth(ButtonText);
	TextHeith = this->ButtonFont.getHeight();

	//ButtonFont.SetColor (this->FontColor_down.r, this->FontColor_down.g, this->FontColor_down.b);

//	ButtonFont.SetColor (150, 0, 0);

	// Draw the button text on the button
//	ButtonFont.drawText(this->ButtonText, ButtonImg_over, width/2 - TextWidth/2, heigth/2 - TextHeith/2);

#if 0
	ButtonFont.SetColors (FontColor_down, ButtonColor);
	ButtonFont.drawText(this->ButtonText, ButtonImg_over, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#else
	ButtonFont.drawText(this->ButtonText, ButtonImg_over, FontColor_down, SizeAndPosition.w/2 - TextWidth/2, SizeAndPosition.h/2 - TextHeith/2);
#endif




}

/* Draws the button to the screen*/
void ButtonClass::drawbutton (void)
{
	// this is the destination as needed for the new surface
	if (this->ButtonState == BUTTON_STATE_UP && this->ButtonImg_up != NULL){
		SDL_BlitSurface(this->ButtonImg_up, NULL, display, &SizeAndPosition);
		//printf ("Blit button up, buttontext = %s, display = %i\n", ButtonText.c_str(), (int)display);
	}else if (this->ButtonState == BUTTON_STATE_DOWN && this->ButtonImg_down != NULL){
		SDL_BlitSurface(this->ButtonImg_down, NULL, display, &SizeAndPosition);
		//printf ("Blit button down, buttontext = %s\n", ButtonText.c_str());
	}else if (this->ButtonState == BUTTON_STATE_OVER && this->ButtonImg_over != NULL){
		SDL_BlitSurface(this->ButtonImg_over, NULL, display, &SizeAndPosition);
		//printf ("Blit button over, buttontext = %s\n", ButtonText.c_str());
	}else
		printf ("%s line %i: Unknown buttonstate\n", __FILE__, __LINE__);

}

//##########################################################################################
//
//	Window widget class
//
//###########################################################################################


// Constructor
RA_WindowClass::RA_WindowClass()
{
	WindowSurface = NULL;
	display = pc::gfxeng->get_SDL_ScreenSurface();

//	this->SetupWindow (Xpos, Ypos, Width, Heigth);
}

// Destructor
RA_WindowClass::~RA_WindowClass()
{
	SDL_FreeSurface(WindowSurface);
}

void RA_WindowClass::SetupWindow (int Xpos, int Ypos, int Width, int Heigth)
{
	SizeAndPosition.x = Xpos;
	SizeAndPosition.y = Ypos;
	SizeAndPosition.w = Width;
	SizeAndPosition.h = Heigth;

	SDL_FreeSurface(WindowSurface);

	WindowSurface = NULL; // not really needed here ;)

	WindowSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, Width, Heigth, 16, 0, 0, 0, 0);

	SDL_SetColorKey(WindowSurface, SDL_SRCCOLORKEY, 0);

	if (pc::Config.gamenum == GAME_RA){
/**
		The image cache somehow gets corrupted by this --> the imagecache is destroyed and recreated in maps.cpp
*/

		int scaleq = -1;

		// Load window images
        	try {
			Background	= pc::imgcache->loadImage("dd-bkgnd.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

        	try {
			LeftBorder	= pc::imgcache->loadImage("dd-left.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

        	try {
			RightBorder	= pc::imgcache->loadImage("dd-right.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

        	try {
			TopBorder	= pc::imgcache->loadImage("dd-top.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

        	try {
			BottomBorder	= pc::imgcache->loadImage("dd-botm.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

        	try {
			Corner		= pc::imgcache->loadImage("dd-crnr.shp", scaleq);
		}catch (ImageNotFound&){
			printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		}

		this->DrawRaBackground ();
	}
}

void RA_WindowClass::ResizeWindow (int Width, int Heigth)
{
	SizeAndPosition.w = Width;
	SizeAndPosition.h = Heigth;

	SDL_FreeSurface(WindowSurface);

	WindowSurface = NULL; // not really needed here ;)

	WindowSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, Width, Heigth, 16, 0, 0, 0, 0);

	SDL_SetColorKey(WindowSurface, SDL_SRCCOLORKEY, 0);

	if (pc::Config.gamenum == GAME_RA)
		this->DrawRaBackground ();
}


void RA_WindowClass::ChangeWindowPosition (int Xpos, int Ypos)
{
	SizeAndPosition.x = Xpos;
	SizeAndPosition.y = Ypos;
}

void RA_WindowClass::GetWindowPosition (int *Xpos, int *Ypos)
{
	*Xpos = SizeAndPosition.x;
	*Ypos = SizeAndPosition.y;
}

SDL_Surface *RA_WindowClass::GetWindowSurface (void)
{
	return WindowSurface;
}


SDL_Surface *RA_WindowClass::ReadShpImage (char *Name, int ImageNumb)
{
SDL_Surface	*image,
			*shadow;
SHPImage	*TempPic;

	try {
		TempPic = new SHPImage(Name, -1);
	} catch (ImageNotFound&) {
		printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		return NULL;
	}

//	printf ("%s line %i: %s has %i images\n", __FILE__, __LINE__, Name, TempPic->getNumImg());

	TempPic->getImage(ImageNumb, &image, &shadow, 1);

	delete TempPic;

	SDL_FreeSurface(shadow);

//	SDL_SetColorKey(image,SDL_SRCCOLORKEY, 0xffffff);

	return image;
}

void RA_WindowClass::DrawRaBackground (void)
{
SDL_Rect	dest;
SDL_Surface	*Image;
int		topspacing, botspacing;

	Uint32 BlackColor = SDL_MapRGB(display->format, 10, 10, 10);

	//
	// Draw the image background
	//
	dest.x = 0;
	dest.y = 0;
	dest.w = WindowSurface->w;
	dest.h = WindowSurface->h;
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-bkgnd.shp", 0))!=NULL){
#else
	if ((Image = pc::imgcache->getImage( Background, 0 ).image) != NULL){
#endif
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		if (WindowSurface->w > Image->w){
			dest.x = Image->w;
			dest.w = WindowSurface->w - Image->w;
			dest.h = WindowSurface->h;
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
			if (WindowSurface->h > Image->h){
				dest.y = Image->h;
				SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
			}
		}
		if (WindowSurface->h > Image->h){
			dest.x = 0;
			dest.y = Image->h;
			dest.w = WindowSurface->w;
			dest.h = WindowSurface->h;
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}else
		printf ("%s line %i: Failed to load image\n", __FILE__, __LINE__);

	//###################################################
	//
	// Draw the top edge
	//
	//###################################################

#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-top.shp", 0))!=NULL){
#else
	if ((Image = pc::imgcache->getImage( TopBorder, 0 ).image) != NULL){
#endif
		dest.x = 0;
		dest.y = 0;
		dest.w = WindowSurface->w;
		dest.h = Image->h;
		topspacing = Image->h;
		SDL_FillRect(WindowSurface, &dest, BlackColor);
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		if (WindowSurface->w > Image->w){
			dest.x = Image->w;
			dest.w = WindowSurface->w - Image->w;
			dest.h = Image->h;
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the bottom window border
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-botm.shp", 0))!=NULL){
#else
	if ((Image = pc::imgcache->getImage( BottomBorder, 0 ).image) != NULL){
#endif
		dest.x = 0;
		dest.y = WindowSurface->h - Image->h;
		dest.w = WindowSurface->w;
		dest.h = Image->h;
		botspacing = Image->h;
		SDL_FillRect(WindowSurface, &dest, BlackColor);
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		if (WindowSurface->w > Image->w){
			dest.x = Image->w;
			dest.w = WindowSurface->w - Image->w;
			dest.h = Image->h;
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the left edge
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-left.shp", 0))!=NULL){
#else
	if ((Image = pc::imgcache->getImage( LeftBorder, 0 ).image) != NULL){
#endif
		dest.x = 0;
		dest.y = 0;
		dest.w = Image->w;
		dest.h = WindowSurface->h;
		SDL_FillRect(WindowSurface, &dest, BlackColor);
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		if (WindowSurface->w > Image->w){
			dest.x = 0;
			dest.y = Image->h;
			dest.w = Image->w;
			dest.h = WindowSurface->h - Image->h;
			SDL_FillRect(WindowSurface, &dest, BlackColor);
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the rigth edge
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-right.shp", 0))!= NULL){
#else
	if ((Image = pc::imgcache->getImage( RightBorder, 0 ).image) != NULL){
#endif
		dest.x = WindowSurface->w - Image->w;
		dest.y = 0;
		dest.w = Image->w;
		dest.h = WindowSurface->h;
		SDL_FillRect(WindowSurface, &dest, BlackColor);
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		if (WindowSurface->w > Image->w){
			dest.x = WindowSurface->w - Image->w;
			dest.y = Image->h;
			dest.w = Image->w;
			dest.h = WindowSurface->h - Image->h;
			SDL_FillRect(WindowSurface, &dest, BlackColor);
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the left/top corner
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-crnr.shp", 0)) != NULL){
#else
	if ((Image = pc::imgcache->getImage( Corner, 0 ).image) != NULL){
#endif
		dest.x = 0;
		dest.y = 0;
		dest.w = Image->w;
		dest.h = Image->h;
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the rigth/top corner
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-crnr.shp", 1)) != NULL){
#else
	if ((Image = pc::imgcache->getImage( Corner, 1 ).image) != NULL){
#endif
		dest.x = WindowSurface->w - Image->w;
		dest.y = 0;
		dest.w = Image->w;
		dest.h = Image->h;
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the left/bottum corner
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-crnr.shp", 2)) != NULL){
#else
	if ((Image = pc::imgcache->getImage( Corner, 2 ).image) != NULL){
#endif
		dest.x = 0;
		dest.y = WindowSurface->h - Image->h;
		dest.w = Image->w;
		dest.h = Image->h;
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		SDL_FreeSurface(Image);
	}

	//###################################################
	//
	// Draw the rigth/bottum corner
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-crnr.shp", 3)) != NULL){
#else
	if ((Image = pc::imgcache->getImage( Corner, 3 ).image) != NULL){
#endif
		dest.x = WindowSurface->w - Image->w;
		dest.y = WindowSurface->h - Image->h;
		dest.w = Image->w;
		dest.h = Image->h;
		SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		SDL_FreeSurface(Image);
	}

#if 0
	//###################################################
	//
	// Draw the left edge decoration
	//
	//###################################################
#ifndef USE_IMAGE_POOL
	if ((Image = this->ReadShpImage ("dd-edge.shp", 0))!=NULL){
#else
	if ((Image = pc::imgcache->getImage( Edge, 3 ).image) != NULL){
#endif
		for (int i = topspacing; i < (WindowSurface->h - botspacing); i+=Image->h){
			dest.x = 11;
			dest.y = i;
			dest.w = Image->w;
			dest.h = WindowSurface->h;
			SDL_BlitSurface(Image, NULL, WindowSurface, &dest);
		}
		SDL_FreeSurface(Image);
	}
#endif
}

void RA_WindowClass::SolidFill (Uint8 red, Uint8 green, Uint8 blue)
{

	Uint32 Color = SDL_MapRGB(WindowSurface->format, red, green, blue);
	// Fill the surface with the correct color
	SDL_FillRect(WindowSurface, &SizeAndPosition, Color);
}


void RA_WindowClass::DrawWindow (void)
{
/*
SDL_Rect dest;

	dest.x = 0;
	dest.y = 0;
	dest.w = WindowSurface->w;
	dest.h = WindowSurface->h;
*/
	SDL_BlitSurface(WindowSurface, NULL, display, &SizeAndPosition);

}

ListboxClass::ListboxClass()
{
	ListBoxSurface	= NULL;
	btn_up			= NULL;
	btn_down		= NULL;


	ScrollPos	= 0;
	SelectPos	= 0;
	With		= 350;
	NumbLines	= 8;
	ListBoxType	= LISTBOX_TYPE_NORMAL;
//	ListBoxType	= LISTBOX_TYPE_CHECK;
	DisplaySurface	= pc::gfxeng->get_SDL_ScreenSurface();

	btn_up_down		= false;
	btn_down_down	= false;


	printf ("ListBox class initialized\n");
}

ListboxClass::~ListboxClass()
{
	SDL_FreeSurface(ListBoxSurface);
}

SDL_Surface *ListboxClass::ReadShpImage (char *Name, int ImageNumb, Uint8 palnum)
{
SDL_Surface	*image,
			*shadow;
SHPImage	*TempPic;



	try {
		TempPic = new SHPImage(Name, -1);
	} catch (ImageNotFound&) {
		printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		return NULL;
	}

//	TempPic->setPalette(SDL_Color *pal)

//	printf ("%s line %i: %s has %i images\n", __FILE__, __LINE__, Name, TempPic->getNumImg());

	TempPic->getImage(ImageNumb, &image, &shadow, palnum);

	delete TempPic;

	SDL_FreeSurface(shadow);

	SDL_SetColorKey(image,SDL_SRCCOLORKEY, 0xffffff);

	return image;
}


int ListboxClass::GetSelectionIndex (void)
{
	return (/*ScrollPos + */SelectPos);
}

void ListboxClass::SetType (unsigned int type)
{
	if (type < LISTBOX_TYPE_NORMAL || type > LISTBOX_TYPE_CHECK)
		return;

	ListBoxType	= type;
}

bool ListboxClass::IsChecked (unsigned int line)
{
	if (ListBoxType != LISTBOX_TYPE_CHECK)
		return false;

	if (line >= CheckedList.size())
		return false;

	if (CheckedList[line])
		return true;

	return false;
}


void ListboxClass::AddString (const std::string String)
{
	// Add the text to the list
	MessageList.push_back (String);
	CheckedList.push_back (false);
	Recreate = true;
}

SDL_Surface* ListboxClass::geDrawingSurface(void)
{
	return ListBoxSurface;
}

void ListboxClass::ScrollUp (void)
{
//	if (SelectPos > 0){
//		SelectPos--;
//		Recreate = true;
//	}else 
	if (ScrollPos > 0){
		ScrollPos--;
		Recreate = true;
	}
}

void ListboxClass::ScrollDown (void)
{
//	if (SelectPos < NumbLines - 1){
//		SelectPos++;
//		Recreate = true;
//	}else 
	if ((Uint16)(ScrollPos + 1) < ((Uint16)MessageList.size() - NumbLines)){
		ScrollPos++;
		Recreate = true;
	}
}

void ListboxClass::HandleInput(SDL_Event event)
{
int MouseXpos, MouseYpos;


	switch (event.type) {
		case SDL_MOUSEBUTTONDOWN:
			//printf ("%s line %i: Entry = %i\n", __FILE__, __LINE__, mouseover_entry());
			SDL_GetMouseState(&MouseXpos, &MouseYpos);

			// Handle item selection by mouse click
			if (ListBoxType	== LISTBOX_TYPE_NORMAL){
				if ((MouseXpos > Xpos + LISTBOX_BORDER_WITH) && (MouseXpos < (ListBoxSurface->w + Xpos - LISTBOX_SCROLLBAR_WITH - LISTBOX_BORDER_WITH))){
					if ((MouseYpos > Ypos + LISTBOX_BORDER_WITH) && (MouseYpos < (ListBoxSurface->h + Ypos - LISTBOX_BORDER_WITH))){
						Uint16 pos = (MouseYpos - Ypos - LISTBOX_BORDER_WITH) / (FontHeigth+LISTBOX_FONT_LINE_SPACING);
						if ((unsigned)(pos + ScrollPos) < MessageList.size()){
							SelectPos = pos + ScrollPos;
							Recreate = true;
						}
					}
				}
			}else if (ListBoxType	== LISTBOX_TYPE_CHECK){
				if ((MouseXpos > Xpos + LISTBOX_BORDER_WITH) && (MouseXpos < (ListBoxSurface->w + Xpos - LISTBOX_SCROLLBAR_WITH - LISTBOX_BORDER_WITH))){
					if ((MouseYpos > Ypos + LISTBOX_BORDER_WITH) && (MouseYpos < (ListBoxSurface->h + Ypos - LISTBOX_BORDER_WITH))){
						Uint16 pos = (MouseYpos - Ypos - LISTBOX_BORDER_WITH) / (FontHeigth+LISTBOX_FONT_LINE_SPACING);
						if ((unsigned)(pos + ScrollPos) < CheckedList.size()){
							if (CheckedList[pos + ScrollPos] == false)
								CheckedList[pos + ScrollPos] = true;
							else
								CheckedList[pos + ScrollPos] = false;
							Recreate = true;
						}
					}
				}
			}

			// Handle the scrollup button
			if (this->MouseOverArrowDown ()){
				this->ScrollDown ();
				btn_down_down = true;
			}

			// Handle the scrolldown button
			if (this->MouseOverArrowUp ()){
				this->ScrollUp ();
				btn_up_down = true;
			}
			break;

		case SDL_MOUSEBUTTONUP:
			if (btn_up_down){
				btn_up_down = false;
				Recreate = true;
			}
			if (btn_down_down){
				btn_down_down = false;
				Recreate = true;
			}
			break;

		case SDL_KEYDOWN:

			switch (event.key.keysym.sym){
				case SDLK_BACKSPACE:
				case SDLK_TAB:
				case SDLK_RSHIFT:
				case SDLK_LSHIFT:
					break;
				default:
					break;

			}
			break;

	}
}



bool ListboxClass::MouseOverArrowUp (void)
{
int MouseXpos, MouseYpos;

	if (ListBoxSurface == NULL)
		return false;

	SDL_GetMouseState(&MouseXpos, &MouseYpos);

	if ((MouseXpos > (ListBoxSurface->w + Xpos - LISTBOX_SCROLLBAR_WITH)) && (MouseXpos < (ListBoxSurface->w + Xpos)))
		if ((MouseYpos > Ypos) && (MouseYpos < Ypos + LISTBOX_ARROW_UPDOWN_HEIGTH))
			return true;

	return false;
}

bool ListboxClass::MouseOverArrowDown (void)
{
int MouseXpos, MouseYpos;

	SDL_GetMouseState(&MouseXpos, &MouseYpos);

	if ((MouseXpos > (ListBoxSurface->w + Xpos - LISTBOX_SCROLLBAR_WITH)) && (MouseXpos < (ListBoxSurface->w + Xpos)))
		if ((MouseYpos > Ypos + ListBoxSurface->h - LISTBOX_ARROW_UPDOWN_HEIGTH) && (MouseYpos < Ypos + ListBoxSurface->h))
			return true;

	return false;
}


// Create the listbox surface to draw
void ListboxClass::CreateListBox (void)
{
SDL_Rect	dest;
SDL_Surface	*TempImage;
Font		Font("type.fnt"/*"scorefnt.fnt"*/);
int		BorderWidth = LISTBOX_BORDER_WITH, 
		Spacing = LISTBOX_FONT_LINE_SPACING;
SDL_Color 	RGB_ColWhite;

	if (!btn_up_down)
		btn_up = ReadShpImage ("btn-up.shp", 0, 2);
	else
		btn_up = ReadShpImage ("btn-up.shp", 1, 2);

	if (!btn_down_down)
		btn_down = ReadShpImage ("btn-dn.shp", 0, 2);
	else
		btn_down = ReadShpImage ("btn-dn.shp", 1, 2);
//
// Make buttons from blue to red
// Stupid hack, but don't know how else to do this
//
#if 1
	if (btn_up != NULL && btn_down != NULL){
		Uint8 Col_red;
		SDL_Color color;
		for (Uint32 x = 0; x < (Uint32) btn_up->w; x++){
			for (Uint32 y = 0; y < (Uint32) btn_up->h; y++){
				get_pixel ( btn_up, color, x, y );
				Col_red = color.r;
				color.r = (color.b+10)&0xff;
				if (color.g > 50)
					color.g = 50;
				color.b = Col_red-10;
				set_pixel (btn_up, color, x, y );
			}
		}

		for (Uint32 x = 0; x < (Uint32) btn_down->w; x++){
			for (Uint32 y = 0; y < (Uint32) btn_down->h; y++){
				get_pixel ( btn_down, color, x, y );
				Col_red = color.r;
				color.r = (color.b+10)&0xff;
				if (color.g > 50)
					color.g = 50;
				color.b = Col_red-10;
				set_pixel (btn_down, color, x, y );
			}
		}
	}
#endif

	RGB_ColWhite.r = RGB_ColWhite.g = RGB_ColWhite.b = 255;

	this->FontHeigth = Font.getHeight();

	SDL_FreeSurface(ListBoxSurface);

	ListBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, With, ((2 * BorderWidth) + (this->FontHeigth * NumbLines) + (NumbLines* Spacing)), 16, 0, 0, 0, 0);

	Uint32 ColBlack = SDL_MapRGB(DisplaySurface->format, 1, 1, 1);
	Uint32 ColRed	= SDL_MapRGB(DisplaySurface->format, 255, 0, 0);

	dest.x = 0;
	dest.y = 0;
	dest.w = ListBoxSurface->w;
	dest.h = ListBoxSurface->h;

	SDL_FillRect(ListBoxSurface, &dest, ColBlack);

	// Draw a rectange around the text area
	dest.x = 0;
	dest.w = ListBoxSurface->w;
	dest.h = 1;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	dest.y = ListBoxSurface->h - 1;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	dest.y = 0;
	dest.w = 1;
	dest.h = ListBoxSurface->h;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	dest.x = ListBoxSurface->w - 1 - LISTBOX_SCROLLBAR_WITH;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	dest.x = ListBoxSurface->w - 1;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);

#if 1
	// Draw the scroll up/down icons
	dest.x = ListBoxSurface->w - btn_up->w; //LISTBOX_SCROLLBAR_WITH;
	dest.y = 0;
	dest.w = btn_up->w; //LISTBOX_SCROLLBAR_WITH;
	dest.h = btn_up->h; //LISTBOX_ARROW_UPDOWN_HEIGTH;
//	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	SDL_BlitSurface(btn_up, NULL, ListBoxSurface, &dest);
	dest.y = ListBoxSurface->h - btn_down->h; //LISTBOX_ARROW_UPDOWN_HEIGTH;
	SDL_BlitSurface(btn_down, NULL, ListBoxSurface, &dest);
//	SDL_FillRect(ListBoxSurface, &dest, ColRed);
#else
	// Draw the scroll up/down icons
	dest.x = ListBoxSurface->w - LISTBOX_SCROLLBAR_WITH;
	dest.y = 0;
	dest.w = LISTBOX_SCROLLBAR_WITH;
	dest.h = LISTBOX_ARROW_UPDOWN_HEIGTH;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
	dest.y = ListBoxSurface->h - LISTBOX_ARROW_UPDOWN_HEIGTH;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);

#endif

/*
	// Draw the selection line
	dest.x = 0;
	dest.y = SelectPos * (this->FontHeigth + Spacing) - 1 + BorderWidth;
	dest.w = ListBoxSurface->w - LISTBOX_SCROLLBAR_WITH;
	dest.h = this->FontHeigth + 3;
	SDL_FillRect(ListBoxSurface, &dest, ColRed);
*/

	if (MessageList.size() <= 0)
		return;

	if (ScrollPos >= MessageList.size())
		ScrollPos = MessageList.size() - 1;

	// Draw the font images on the listbox surface
	for (Uint16 i = 0; i < NumbLines; i++){

		if ((unsigned)(i+ScrollPos) < MessageList.size()){
	
			TempImage = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, ListBoxSurface->w - LISTBOX_SCROLLBAR_WITH  - 2 * BorderWidth/*Font.calcTextWidth(MessageList[i+ScrollPos])*/, this->FontHeigth, 16, 0, 0, 0, 0);

			if (ListBoxType	== LISTBOX_TYPE_NORMAL){
				if (i == (SelectPos - ScrollPos)){
					// Draw the selection line
					dest.x = 0;
					dest.y = 0;
					dest.w = ListBoxSurface->w - LISTBOX_SCROLLBAR_WITH - 10;
					dest.h = this->FontHeigth;
					SDL_FillRect(TempImage, &dest, ColRed);
					Font.drawText(MessageList[i+ScrollPos], TempImage, RGB_ColWhite, 5, 0);
				}else{
					Font.drawText(MessageList[i+ScrollPos], TempImage, RGB_ColWhite, 5, 0);
				}
			}else if (ListBoxType	== LISTBOX_TYPE_CHECK){
				if (CheckedList[i + ScrollPos]){
					// Draw the selection line
					dest.x = 0;
					dest.y = 0;
					dest.w = ListBoxSurface->w - LISTBOX_SCROLLBAR_WITH - 10;
					dest.h = this->FontHeigth;
					SDL_FillRect(TempImage, &dest, ColRed);
					//Font.SetColor (200, 200, 200);
					Font.drawText(MessageList[i+ScrollPos], TempImage, RGB_ColWhite, 5, 0);
				}else{
					//Font.SetColor (200, 200, 200);
					Font.drawText(MessageList[i+ScrollPos], TempImage, RGB_ColWhite, 5, 0);
				}
			}

			dest.x = BorderWidth;
			dest.w = With - 2*BorderWidth;
			dest.y = (FontHeigth * i) + (Spacing * i) + BorderWidth; //TempImage->h * i;
			dest.h = TempImage->h;
			SDL_BlitSurface(TempImage, NULL, ListBoxSurface, &dest);

			SDL_FreeSurface(TempImage);
		}
	}



	Recreate = false;
}


void ListboxClass::DrawListBox (int X, int Y)
{
SDL_Rect dest;

	Xpos = X;
	Ypos = Y;

	if (Recreate)
		this->CreateListBox ();

	if (ListBoxSurface == NULL)
		return;

	dest.x = Xpos;
	dest.y = Ypos;
	dest.w = With;
	dest.h = FontHeigth * NumbLines;

	if (DisplaySurface != NULL)
		SDL_BlitSurface(ListBoxSurface, NULL, DisplaySurface, &dest);
}

TCheckBox::TCheckBox()
{
	// Setup some vars
	Checked		= false;
	Width		= 20, 
	Heigth		= 20;
	CheckBoxSurface = NULL;

	// Initialize the surfaces
	DisplaySurface	= pc::gfxeng->get_SDL_ScreenSurface();
	this->Create ();

	// Initialize the checkbox color
	CheckboxColor		= SDL_MapRGB(DisplaySurface->format, 0xff, 0, 0);
	CheckboxBackgroundColor	= SDL_MapRGB(DisplaySurface->format, 0, 0, 0);



}

TCheckBox::~TCheckBox(){
	SDL_FreeSurface(CheckBoxSurface);
}

void TCheckBox::Create (void)
{
SDL_Rect	dest;

	if (CheckBoxSurface != NULL)
		SDL_FreeSurface(CheckBoxSurface);

	CheckBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, Width, Heigth, 16, 0, 0, 0, 0);

	// this is the destination as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = Width;
	dest.h = Heigth;

	// Fill the surface with the correct color
	SDL_FillRect(CheckBoxSurface, &dest, CheckboxColor);

	// this is the destination as needed for the new surface
	dest.x = 1;
	dest.y = 1;
	dest.w = Width-2;
	dest.h = Heigth-2;

	// Fill the surface with the correct color
	SDL_FillRect(CheckBoxSurface, &dest, CheckboxBackgroundColor);
}


void TCheckBox::Draw(int X, int Y)
{
SDL_Rect dest;

	if (CheckBoxSurface == NULL)
		return;

	if (DisplaySurface == NULL)
		return;

//	printf ("Draw checkbox\n");

	dest.x = X;
	dest.y = Y;
	dest.w = Width;
	dest.h = Heigth;

	SDL_BlitSurface(CheckBoxSurface, NULL, DisplaySurface, &dest);
}

//********************************************************************************************************************************
//********************************************************************************************************************************
//********************************************************************************************************************************
//********************************************************************************************************************************

TTextBox::TTextBox ():TextBoxFont("type.fnt"/*"scorefnt.fnt"*/){

	// Setup some vars
	Selected	= false;
	Recreate	= true;
	TextBoxSurface	= NULL;
	DisplaySurface	= NULL;
	WindowToDrawOn	= NULL;

	SizeAndPosition.x = 0;
	SizeAndPosition.y = 0;
	SizeAndPosition.w = 100;
	SizeAndPosition.h = 16;

	// Initialize the surfaces
	DisplaySurface	= pc::gfxeng->get_SDL_ScreenSurface();
	//TextBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, Width, Heigth, 16, 0, 0, 0, 0);


	// Initialize the checkbox color
	TextColor		= SDL_MapRGB(DisplaySurface->format, 0xff, 0, 0);
	TextBoxColor		= SDL_MapRGB(DisplaySurface->format, 0xff, 0, 0);
	TextBoxBackgroundColor	= SDL_MapRGB(DisplaySurface->format, 0, 0, 0);

	SDL_EnableUNICODE(true);

	// Initialize the text
	TextBoxString = "Player";
}

TTextBox::~TTextBox(){

}

// Set the surface (window) to draw the button on
void TTextBox::SetDrawingWindow(RA_WindowClass *Window)
{
	if (Window != NULL){
		WindowToDrawOn = Window;
		//display = WindowToDrawOn->GetWindowSurface ();
	}

}

bool TTextBox::need_redraw(void)
{
	return Recreate;
}

void TTextBox::Create (void)
{
SDL_Rect	dest;
Uint16		Ypos;
char		*temp;


	Recreate	= false;

	temp = (char *) TextBoxString.c_str();

//	printf ("%s line %i: Recreate text box, text = %s\n", __FILE__, __LINE__, temp);

	if (TextBoxSurface != NULL){
		//printf ("Free surface\n");
		SDL_FreeSurface(TextBoxSurface);
	}

	TextBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);

	// this is the destinatc_strion as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = SizeAndPosition.w;
	dest.h = SizeAndPosition.h;

	// Fill the surface with the correct color
	SDL_FillRect(TextBoxSurface, &dest, TextBoxColor);

	// this is the destination as needed for the new surface
	dest.x = 1;
	dest.y = 1;
	dest.w = SizeAndPosition.w-2;
	dest.h = SizeAndPosition.h-2;

	// Fill the surface with the correct color
	SDL_FillRect(TextBoxSurface, &dest, TextBoxBackgroundColor);

	if ((unsigned) SizeAndPosition.h < (unsigned) TextBoxFont.getHeight())
		return;

	if ((unsigned)  SizeAndPosition.w-8 < (unsigned) TextBoxFont.calcTextWidth(TextBoxString))
		return;


	Ypos = (SizeAndPosition.h - TextBoxFont.getHeight())/2;

	TextBoxFont.drawText(TextBoxString, TextBoxSurface, TextColor, 4, Ypos) ; //drawText("Your color", ListBox.geDrawingSurface(), 100, 20);
}

bool TTextBox::setText(const std::string& newtext)
{
	if ((unsigned) SizeAndPosition.h-2 < (unsigned) TextBoxFont.getHeight())
		return false;

	if ((unsigned)  SizeAndPosition.w-8 < (unsigned) TextBoxFont.calcTextWidth(newtext))
		return false;

	TextBoxString = newtext;
	Recreate = true;

	return true;
}

char *TTextBox::getText(void)
{
	return (char*)TextBoxString.c_str();
}


bool TTextBox::AddChar(char AddChar)
{
std::string	newtext;

	newtext = TextBoxString;

	newtext += AddChar;

	if ((unsigned) SizeAndPosition.h < (unsigned) TextBoxFont.getHeight())
		return false;

	if ((unsigned)  SizeAndPosition.w-8 < (unsigned) TextBoxFont.calcTextWidth(newtext))
		return false;

	TextBoxString = newtext;

	Recreate = true;

	return true;
}

bool TTextBox::DeleteChar(unsigned int pos)
{
	if (TextBoxString.size() > pos){
		TextBoxString.erase (pos, 1);
	}else
		return false;

	Recreate = true;

	return true;
}


/* Function return true if the mouse is on top of the button */
bool TTextBox::mouseover(void)
{
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}


	if (mx > SizeAndPosition.x && mx < SizeAndPosition.x + SizeAndPosition.w)
		if (my > SizeAndPosition.y && my < SizeAndPosition.y + SizeAndPosition.h)
			return true;
	return false;
}


void TTextBox::HandleInput(SDL_Event event)
{
//SDL_Event event;
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}


	switch (event.type) {
		case SDL_MOUSEBUTTONDOWN:
			if (mouseover()){
				//printf ("Selected\n");
				Selected = true;
			}else{
				//printf ("Not selected\n");
				Selected = false;
			}
			break;

		case SDL_MOUSEBUTTONUP:
			break;

		case SDL_KEYDOWN:
			if (!Selected)
				return;

			switch (event.key.keysym.sym){
				case SDLK_BACKSPACE:
					// Remove last char
					this->DeleteChar(TextBoxString.size() - 1);
					break;
				case SDLK_TAB:
				case SDLK_RSHIFT:
				case SDLK_LSHIFT:
					break;
				default:
					//SDL_EnableUNICODE(true); is needed for this to work ;)
					char ch = 0;
					if ( (event.key.keysym.unicode & 0xFF80) == 0 ) {
  						ch = event.key.keysym.unicode & 0x7F;
						//printf ("Character = %c\n", ch);
						if ((ch >= '0' && ch <= '9') || (ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'))
							this->AddChar (ch);
					}
					break;

			}
			break;

	}
}


bool TTextBox::Draw(int X, int Y)
{

	// Set size and posisiton
	SizeAndPosition.x = X;
	SizeAndPosition.y = Y;

	if (this->Recreate)
		Create();

	if (TextBoxSurface == NULL)
		return false;

	if (DisplaySurface == NULL)
		return false;

	if (WindowToDrawOn != NULL)
		SDL_BlitSurface(TextBoxSurface, NULL, WindowToDrawOn->GetWindowSurface (), &SizeAndPosition);
	else
		SDL_BlitSurface(TextBoxSurface, NULL, DisplaySurface, &SizeAndPosition);

	return true;
}


//********************************************************************************************************************************
//********************************************************************************************************************************
//********************************************************************************************************************************
//******************************************************************************************************************************** 
DropDownListBox::DropDownListBox ():ListBoxFont("type.fnt"){
	List.empty();
	ListBoxSurface	= NULL;
	DisplaySurface	= NULL;
	WindowToDrawOn	= NULL;
	ArrowDownImage	= NULL;

	SizeAndPosition.x = 0;
	SizeAndPosition.y = 0;
	SizeAndPosition.w = 100;
	SizeAndPosition.h = 16;

	SelectedIndex	= 0;
	Selected		= false;
	Recreate		= true;
	button_down		= false;

	// Initialize the surfaces
	DisplaySurface	= pc::gfxeng->get_SDL_ScreenSurface();

	// Initialize the checkbox color
	ListBoxColor			= SDL_MapRGB(DisplaySurface->format, 0xff, 0, 0);
	TextColor				= SDL_MapRGB(DisplaySurface->format, 0xff, 0, 0);
	ListBoxBackgroundColor	= SDL_MapRGB(DisplaySurface->format, 0, 0, 0);

}

DropDownListBox::~DropDownListBox()
{
	if (ListBoxSurface != NULL)
		SDL_FreeSurface( ListBoxSurface );

#ifndef USE_IMAGE_POOL
	if (ArrowDownImage != NULL)
		SDL_FreeSurface( ArrowDownImage );
#endif
}



SDL_Surface *DropDownListBox::ReadShpImage (char *Name, int ImageNumb, Uint8 palnum)
{
SDL_Surface	*image,
			*shadow;
SHPImage	*TempPic;



	try {
		TempPic = new SHPImage(Name, -1);
	} catch (ImageNotFound&) {
		printf ("%s line %i: Image not found\n", __FILE__, __LINE__);
		return NULL;
	}

//	TempPic->setPalette(SDL_Color *pal)

//	printf ("%s line %i: %s has %i images\n", __FILE__, __LINE__, Name, TempPic->getNumImg());

	TempPic->getImage(ImageNumb, &image, &shadow, palnum);

	delete TempPic;

	SDL_FreeSurface(shadow);

	SDL_SetColorKey(image,SDL_SRCCOLORKEY, 0xffffff);

	return image;
}

// Set the surface (window) to draw the button on
void DropDownListBox::SetDrawingWindow(RA_WindowClass *Window)
{
	if (Window != NULL){
		WindowToDrawOn = Window;
	}
}

bool DropDownListBox::need_redraw(void)
{
	return Recreate;
}


// Set the surface (window) to draw the button on
void DropDownListBox::AddEntry(std::string Entry)
{
	List.push_back(Entry);
}


//
// Moet gebruik gaan maken van: btn-dn.shp and btn-up.shp
//
void DropDownListBox::Create (void)
{
SDL_Rect	dest;
Uint16		Ypos;
//char		*temp;


	Recreate	= false;

	if (ListBoxSurface != NULL){
		//printf ("Free surface\n");
		SDL_FreeSurface(ListBoxSurface);
	}

	Spacing = (SizeAndPosition.h - ListBoxFont.getHeight())/2;


	if (Selected){
		ListBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, (SizeAndPosition.h + Spacing + (SizeAndPosition.h - Spacing)* List.size() ), 16, 0, 0, 0, 0);
	}else{
		ListBoxSurface = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);
	}

	// this is the destinatc_strion as needed for the new surface
	dest.x = 0;
	dest.y = 0;
	dest.w = ListBoxSurface->w;
	dest.h = ListBoxSurface->h;

	// Fill the surface with the correct color
	SDL_FillRect(ListBoxSurface, &dest, ListBoxColor);

	// this is the destination as needed for the new surface
	dest.x = 1;
	dest.y = 1;
	dest.w = ListBoxSurface->w-2;
	dest.h = SizeAndPosition.h-2;

	// Fill the surface with the correct color
	SDL_FillRect(ListBoxSurface, &dest, ListBoxBackgroundColor);

	if (Selected){

		// this is the destination as needed for the new surface
		dest.x = 1;
		dest.y = SizeAndPosition.h;
		dest.w = ListBoxSurface->w-2;
		dest.h = ListBoxSurface->h - 2 -SizeAndPosition.h;

		// Fill the surface with the correct color
		SDL_FillRect(ListBoxSurface, &dest, ListBoxBackgroundColor);	
	}

	if ((unsigned) SizeAndPosition.h < (unsigned) ListBoxFont.getHeight())
		return;

	if (SelectedIndex < List.size()){
		if ((unsigned)  SizeAndPosition.w-8 < (unsigned) ListBoxFont.calcTextWidth(List[SelectedIndex]))
			return;
	}

	if (Selected)
		Ypos = SizeAndPosition.h + (SizeAndPosition.h - ListBoxFont.getHeight())/2;
	else
		Ypos = (SizeAndPosition.h - ListBoxFont.getHeight())/2;

//	printf ("Ypos = %i\n", Ypos);

	if (SelectedIndex < List.size()){
		if (Selected){
			for (Uint32 i = 0; i< List.size(); i++){
				ListBoxFont.drawText(List[i], ListBoxSurface, TextColor, 4, Ypos) ; //drawText("Your color", ListBox.geDrawingSurface(), 100, 20);
				Ypos += ListBoxFont.getHeight()+Spacing;
			}
		}else{
			ListBoxFont.drawText(List[SelectedIndex], ListBoxSurface, TextColor, 4, Ypos) ; //drawText("Your color", ListBox.geDrawingSurface(), 100, 20);
		}
	}
#if 1
if (!button_down){
#ifndef USE_IMAGE_POOL
	if ((ArrowDownImage = this->ReadShpImage ("btn-dn.shp", 0, 2)) == NULL){
#else
	if ((ArrowDownImage = pc::imgcache->getImage( "btn-dn.shp", 0 ).image) == NULL){
#endif
		printf ("%s line %i: Failed to load button down image\n", __FILE__, __LINE__);
	}
}else{
#ifndef USE_IMAGE_POOL
	if ((ArrowDownImage = this->ReadShpImage ("btn-dn.shp", 1, 2)) == NULL){
#else
	if ((ArrowDownImage = pc::imgcache->getImage( "btn-dn.shp", 1 ).image) == NULL){
#endif
		printf ("%s line %i: Failed to load button down image\n", __FILE__, __LINE__);
	}


}

#if 1
	Uint8 ColRed;
	SDL_Color color;
	for (Uint32 x = 0; x < (Uint32) ArrowDownImage->w; x++){
		for (Uint32 y = 0; y < (Uint32) ArrowDownImage->h; y++){
		get_pixel ( ArrowDownImage, color, x, y );
		ColRed = color.r;
		color.r = (color.b+10)&0xff;
		if (color.g > 50)
		color.g = 50;
		color.b = ColRed-10;
		set_pixel (ArrowDownImage, color, x, y );
//		printf ("Col = %x\n", Temp[i]);
//		Temp[i] += 50;
		}
	}
#endif
#endif



	// Fill the surface with the correct color
//ArrowDownImage = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY, SizeAndPosition.w, SizeAndPosition.h, 16, 0, 0, 0, 0);

}
/* Function return true if the mouse is on top of the button */
bool DropDownListBox::mouseover_button(void)
{
int mx, my;
int WinXpos = 0, WinYpos = 0;

	if (ArrowDownImage == NULL)
		return false;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}

	if (mx > SizeAndPosition.x + SizeAndPosition.w - 1 && mx < SizeAndPosition.x + SizeAndPosition.w + ArrowDownImage->w - 1)
		if (my > SizeAndPosition.y && my < (SizeAndPosition.y + SizeAndPosition.h))
			return true;
	return false;
}

/* Function return true if the mouse is on top of the button */
bool DropDownListBox::mouseover(void)
{
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}

	Spacing = (SizeAndPosition.h - ListBoxFont.getHeight())/2;

	if (mx > SizeAndPosition.x && mx < SizeAndPosition.x + SizeAndPosition.w){
		if (my > SizeAndPosition.y && my < (SizeAndPosition.y + (SizeAndPosition.h + Spacing + (SizeAndPosition.h - Spacing) * (signed)List.size())) && Selected)
			return true;
		if (my > SizeAndPosition.y && my < (SizeAndPosition.y + SizeAndPosition.h) && !Selected)
			return true;
	}
	return false;
}

/* Function returns the index (entry) the mouse is over */
Uint32 DropDownListBox::mouseover_entry(void)
{
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}

	if (!Selected)
		return 0;

	Spacing = (SizeAndPosition.h - ListBoxFont.getHeight())/2;

	if (mx > SizeAndPosition.x && mx < SizeAndPosition.x + SizeAndPosition.w){
		if (my > (SizeAndPosition.y + SizeAndPosition.h) && my < (SizeAndPosition.y + (SizeAndPosition.h + Spacing + (SizeAndPosition.h - Spacing) * (signed)List.size()))){
			return  List.size() - (unsigned)(((SizeAndPosition.y + (SizeAndPosition.h + Spacing + (SizeAndPosition.h - Spacing) * List.size())) - my)/SizeAndPosition.h) - 1;
		}
	}
	return 0;
}

Uint32 DropDownListBox::selected(void)
{
	return SelectedIndex;
}


void DropDownListBox::HandleInput(SDL_Event event)
{
//SDL_Event event;
int mx, my;
int WinXpos = 0, WinYpos = 0;

	SDL_GetMouseState(&mx, &my);

	if (WindowToDrawOn != NULL){
		WindowToDrawOn->GetWindowPosition (&WinXpos, &WinYpos);
		mx -= WinXpos;
		my -= WinYpos;
	}

	switch (event.type) {
		case SDL_MOUSEBUTTONDOWN:
			//printf ("%s line %i: Entry = %i\n", __FILE__, __LINE__, mouseover_entry());

			if (mouseover_button())
				button_down = true;
			if (mouseover() || mouseover_button()){
				if (Selected){
					SelectedIndex = mouseover_entry();
					Selected = false;
				}else{
					Selected = true;
				}
			}else{
				Selected = false;
			}
			Recreate = true;
			break;

		case SDL_MOUSEBUTTONUP:
			if (button_down){
				button_down = false;
				Recreate = true;
			}
			break;

		case SDL_KEYDOWN:
			if (!Selected)
				return;

			switch (event.key.keysym.sym){
				case SDLK_BACKSPACE:
				case SDLK_TAB:
				case SDLK_RSHIFT:
				case SDLK_LSHIFT:
					break;
				default:
					break;

			}
			break;

	}
}


bool DropDownListBox::Draw(int X, int Y)
{
Uint32 Heigth = SizeAndPosition.h;
SDL_Rect	dest;

	// Set size and posisiton
	SizeAndPosition.x = X;
	SizeAndPosition.y = Y;

	if (this->Recreate)
		Create();

	if (ListBoxSurface == NULL)
		return false;

	if (DisplaySurface == NULL)
		return false;

	if (WindowToDrawOn != NULL)
		SDL_BlitSurface(ListBoxSurface, NULL, WindowToDrawOn->GetWindowSurface (), &SizeAndPosition);
	else
		SDL_BlitSurface(ListBoxSurface, NULL, DisplaySurface, &SizeAndPosition);

	if ( ArrowDownImage != NULL ){

		dest.x = SizeAndPosition.x + SizeAndPosition.w - 1;
		dest.y = SizeAndPosition.y;
		dest.w = ArrowDownImage->w;
		dest.h = ArrowDownImage->h;

		if (WindowToDrawOn != NULL){
			SDL_BlitSurface(ArrowDownImage, NULL, WindowToDrawOn->GetWindowSurface (), &dest);
		}else{
			SDL_BlitSurface(ArrowDownImage, NULL, DisplaySurface, &dest);
		}
	}

	SizeAndPosition.h = Heigth;

	return true;
}


